/*
 * prelude.S
 * Copyright (c) 2000 Martin Hinner <mhi@penguin.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
.text

.globl _Stop

_Stop:
       	pushl  $0x5
  	pushl  $0x0
  	movl   NLMID,%eax
       	pushl  %eax
	call   _TerminateNLM
	addl   $0xc,%esp
	ret

_cstart_:
    	pushl  $(main)
    	call   _SetupArgv
  	addl   $0x4,%esp
    	movl   %eax,%edx
    	movl   %edx,%eax
    	ret    

.globl _Prelude
_Prelude:
       	pushl  %ebp
     	movl   %esp,%ebp
   	subl   $0x4,%esp
      	pushl  $(_cstart_)
      	pushl  $(NLMID)
      	movl   0x28(%ebp),%eax
    	pushl  %eax
	movl   0x24(%ebp),%eax
    	pushl  %eax
    	movl   0x20(%ebp),%eax
     	pushl  %eax
  	movl   0x1c(%ebp),%eax
   	pushl  %eax
    	movl   0x18(%ebp),%eax
  	pushl  %eax
    	movl   0x14(%ebp),%eax
      	pushl  %eax
      	movl   0x10(%ebp),%eax
     	pushl  %eax
     	movl   0xc(%ebp),%eax
       	pushl  %eax
      	movl   0x8(%ebp),%eax
       	pushl  %eax
       	call   _StartNLM
       	addl   $0x2c,%esp
       	movl   %eax,0xfffffffc(%ebp)
      	movl   0xfffffffc(%ebp),%eax
       	movl   %ebp,%esp
       	popl   %ebp
       	ret    

.data

.string	"prelude.S Copyright (c) 2000 Martin Hinner <mhi@penguin.cz>\0"

.bss
NLMID:
	.long 0
.end
